/****************************************************************************
** Form interface generated from reading ui file 'src/qjackctlMainForm.ui'
**
** Created by: The User Interface Compiler ($Id: qt/main.cpp   3.3.6   edited Aug 31 2005 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef QJACKCTLMAINFORM_H
#define QJACKCTLMAINFORM_H

#include <qvariant.h>
#include <qwidget.h>
#include <qsettings.h>
#include <qprocess.h>
#include <qsocketnotifier.h>
#include "qjackctlSetup.h"
#include "qjackctlSystemTray.h"
#include "qjackctlPatchbay.h"
#include "qjackctlMessagesForm.h"
#include "qjackctlStatusForm.h"
#include "qjackctlConnectionsForm.h"
#include "qjackctlPatchbayForm.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QPushButton;
class QFrame;
class QLabel;

class qjackctlMainForm : public QWidget
{
    Q_OBJECT

public:
    qjackctlMainForm( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~qjackctlMainForm();

    QPushButton* QuitPushButton;
    QPushButton* StartPushButton;
    QPushButton* StopPushButton;
    QPushButton* StatusPushButton;
    QPushButton* AboutPushButton;
    QPushButton* SetupPushButton;
    QPushButton* MessagesPushButton;
    QPushButton* PatchbayPushButton;
    QPushButton* ConnectionsPushButton;
    QFrame* StatusDisplayFrame;
    QLabel* ServerStateTextLabel;
    QLabel* ServerModeTextLabel;
    QLabel* CpuLoadTextLabel;
    QLabel* SampleRateTextLabel;
    QLabel* XrunCountTextLabel;
    QLabel* TimeDisplayTextLabel;
    QLabel* TransportStateTextLabel;
    QLabel* TransportBPMTextLabel;
    QLabel* TransportTimeTextLabel;
    QPushButton* BackwardPushButton;
    QPushButton* ForwardPushButton;
    QPushButton* RewindPushButton;
    QPushButton* PausePushButton;
    QPushButton* PlayPushButton;

    bool setup( qjackctlSetup * pSetup );
    bool isActivePatchbay( const QString & sPatchbayPath );
    void updateActivePatchbay( void );
    void setActivePatchbay( const QString & sPatchbayPath );
    void setRecentPatchbays( const QStringList & patchbays );
    void stabilizeForm( void );
    void resetXrunStats( void );
    void refreshXrunStats( void );
    void refreshJackConnections( void );
    void refreshAlsaConnections( void );
    void refreshPatchbay( void );

public slots:
    void startJack( void );
    void stopJack( void );
    void readJackStdout( void );
    void appendStdoutBuffer( const QString & s );
    void flushStdoutBuffer( void );
    void processJackExit( void );
    void stdoutNotifySlot( int fd );
    void alsaNotifySlot( int fd );
    void timerSlot( void );
    void jackConnectChanged( void );
    void alsaConnectChanged( void );
    void cableConnectSlot(const QString & sOutputPort, const QString & sInputPort, unsigned int ulCableFlags);
    void toggleMainForm( void );
    void toggleMessagesForm( void );
    void toggleStatusForm( void );
    void toggleConnectionsForm( void );
    void togglePatchbayForm( void );
    void showSetupForm( void );
    void showAboutForm( void );
    void transportRewind();
    void transportBackward();
    void transportStart();
    void transportStop();
    void transportForward();
    void systemTrayContextMenu( const QPoint & pos );
    void activatePresetsMenu ( int iItemID );
    void quitMainForm( void );

protected:
    QGridLayout* qjackctlMainFormLayout;
    QGridLayout* StatusDisplayFrameLayout;

protected slots:
    virtual void languageChange();

private:
    qjackctlSetup *m_pSetup;
    int m_iServerState;
    QProcess *m_pJack;
    jack_client_t *m_pJackClient;
    bool m_bJackDetach;
    bool m_bJackSurvive;
    snd_seq_t *m_pAlsaSeq;
    int m_iStartDelay;
    int m_iTimerDelay;
    int m_iTimerRefresh;
    int m_iJackRefresh;
    int m_iAlsaRefresh;
    int m_iJackDirty;
    int m_iAlsaDirty;
    int m_iStatusRefresh;
    int m_iPatchbayRefresh;
    QSocketNotifier *m_pStdoutNotifier;
    QSocketNotifier *m_pAlsaNotifier;
    int m_iXrunCallbacks;
    int m_iXrunSkips;
    int m_iXrunStats;
    int m_iXrunCount;
    float m_fXrunTotal;
    float m_fXrunMax;
    float m_fXrunMin;
    float m_fXrunLast;
    QTime m_tXrunLast;
    QTime m_tResetLast;
    qjackctlMessagesForm *m_pMessagesForm;
    qjackctlStatusForm *m_pStatusForm;
    qjackctlConnectionsForm *m_pConnectionsForm;
    qjackctlPatchbayForm *m_pPatchbayForm;
    qjackctlPatchbayRack m_patchbayRack;
    qjackctlPreset m_preset;
    QString m_sStdoutBuffer;
    QString m_sTimeDashes;
    QString m_sJackCmdLine;
    qjackctlSystemTray *m_pSystemTray;
    QPopupMenu *m_pPresetsMenu;
    bool m_bQuitForce;
    float m_fSkipAccel;

    void init();
    void destroy();
    bool queryClose( void );
    void closeEvent( QCloseEvent * pCloseEvent );
    void customEvent( QCustomEvent *pCustomEvent );
    QString formatExitStatus ( int iExitStatus );
    void shellExecute( const QString & sShellCommand, const QString & sStartMessage, const QString & sStopMessage );
    void stopJackServer( void );
    QString & detectXrun( QString & s );
    void updateXrunStats( float fXrunLast );
    void appendMessages( const QString & s );
    void appendMessagesColor( const QString & s, const QString & c );
    void appendMessagesText( const QString & s );
    void appendMessagesError( const QString & s );
    void updateMessagesFont( void );
    void updateMessagesLimit( void );
    void updateConnectionsFont( void );
    void updateConnectionsIconSize( void );
    void updateBezierLines( void );
    void updateDisplayEffect( void );
    void updateTimeDisplayFonts( void );
    void updateTimeDisplayToolTips( void );
    void updateTimeFormat( void );
    void updateAliases( void );
    void updateXrunCount( void );
    QString formatTime( double secs );
    QString formatElapsedTime( int iStatusItem, const QTime & t, bool bElapsed );
    void updateElapsedTimes( void );
    void portNotifyEvent( void );
    void xrunNotifyEvent( void );
    void buffNotifyEvent( void );
    void shutNotifyEvent( void );
    bool startJackClient( bool bDetach );
    void stopJackClient( void );
    void refreshConnections( void );
    void refreshStatus( void );
    void updateStatusItem( int iStatusItem, const QString & sText );
    void updateTitleStatus( void );
    void updateServerState( int iState );
    void updateSystemTray( void );
    void showDirtySettingsWarning( void );
    void showDirtySetupWarning( void );
    void contextMenuEvent( QContextMenuEvent *pEvent );

};

#endif // QJACKCTLMAINFORM_H
